make sure residual computation with SUBDIV method fails graciously for 0 counts

04/20/2018 05:34 PM - Tibaldo Luigi

Status: Closed Start date: 04/20/2018

Priority: High Due date:  

Assigned To: Tibaldo Luigi % Done: 100%

Category:  Estimated time: 0.00 hour

Target version: 1.6.0   

Description

Talvikki Hovatta reported failures of csrespec that seem to be related to bins with 0 counts. Make sure that in this case the tool fails

graciously, i.e., still gives output with Nan in empty bins.

History

#1 - 06/12/2018 04:06 PM - Knödlseder Jürgen

- Assigned To set to Tibaldo Luigi

- Priority changed from Normal to High

- Target version set to 1.6.0

#2 - 06/15/2018 05:13 PM - Tibaldo Luigi

- Status changed from New to In Progress

Looking for a test case to reproduce the issue ...

#3 - 06/15/2018 05:45 PM - Tibaldo Luigi

- % Done changed from 0 to 10

In fact it's not csresspec that fails, but just the example plotting script. This is more logical since the SUBDIV method divides by the model (which is

never exactly zero).

Here's the error message, need to look into it

$CTOOLS/share/examples/python/show_residuals.py specres_SUBDIV.fits

Traceback (most recent call last):

File "/usr/local/gamma/share/examples/python/show_residuals.py", line 341, in <module>

show_residuals()

File "/usr/local/gamma/share/examples/python/show_residuals.py", line 329, in show_residuals

plot_residuals(args

0

, plotfile, hdu)

File "/usr/local/gamma/share/examples/python/show_residuals.py", line 211, in plot_residuals

algorithm)

File "/usr/local/gamma/share/examples/python/show_residuals.py", line 117, in fill_cmr

e_resid.append(err / c_model.real(row))

ZeroDivisionError: float division by zero

#4 - 06/15/2018 06:16 PM - Tibaldo Luigi
- Status changed from In Progress to Pull request

- % Done changed from 10 to 100

It does happen for WSTAT that the model is exactly 0 for the Off region.

The case is dealt with in obsutils.residuals, and therefore in csresspec, but it was not in the show_residuals example script when computing the

residual error bars on the fly.

I modified it to set the error to 0 whenever the model is 0 for the SUBDIV and SUBDIVSQRT algorithms.

#5 - 07/02/2018 03:19 PM - Knödlseder Jürgen

- Status changed from Pull request to Closed

Merged into devel.
